Description

I have a web form on a separate site that | have been using with the REST API to create new issues successfully. | have only one
problem: when using the REST API as shown below, it appears to not use the author_id that | define. Instead, the new issue always
ends up having author_id set to the id of the user that is authenticating with the API.

1. Issue model on the client side
class Issue < ActiveResource::Base
self.site = 'http://redmine.server/
self.user = 'foo'
self.password = 'bar'
end

issue = Issue.new(

:subject => 'REST API',

:assigned_to_id => 1,

:project_id => 1,

:author_id =>4 <--- this gets overwritten by id of 'foo’

)

Is setting the author_id not allowable from the REST API or am | missing something? | also tried changing the user and password
dynamically with each new request (i.e. issue.user => 'user’, issue.password => 'password' before issue.save gets called), without
success.

Related issues:
Related to Redmine - Feature #1739: Add ability to change issue author Reopened 2008-08-04

History

#1 - 2010-09-12 17:37 - Felix Schéfer

See source:/trunk/app/controllers/issues_controller.rb#L. 307, the author of an issue will always be the user hitting the crontroller, be it over html or
REST.

#2 - 2010-09-12 19:37 - Eric Davis
- Status changed from New to Closed

- Resolution set to Duplicate

Felix is right. There is a feature request (#1739) for setting author to another user but it's not Redmine yet. (e.g. UserA creates Issue for UserB with
UserB as the "author"). Once it's added to Redmine, it will include API access.

| have some code a client is testing out that does this but it's not ready for release quite yet.

#3 - 2010-09-13 23:09 - Terence Mill

+1

#4 - 2012-06-26 12:32 - Joerg Oswald

+1

#5 - 2013-03-01 15:58 - Paul Wehle

+1
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/app/controllers/issues_controller.rb#L307
https://www.redmine.org/issues/1739

#6 - 2013-03-01 16:46 - Jean-Philippe Lang

Scott Doerrfeld wrote:

Is setting the author_id not allowable from the REST APl or am | missing something?

Setting author_id is not allowed. But you can use User-Impersonation when using the API with an admin account.

#7 - 2013-03-01 16:56 - Paul Wehle

Setting author_id is not allowed. But you can use Rest_api when using the API with an admin account.

Hi Jean-Philippe, sorry | don't understand the meaning of your comment. Could you elaborate please?

In my case I'd like to see who was the user who reported the issue, this is the author of the issue. Since author_id cannot be set through REST API |
am not sure how to achieve this.

Even if using Rest_api with an admin account | believe the author_id cannot be set as shown in create_issue request Rest_Issues where this
parameter does not exist.

#8 - 2013-03-01 17:37 - Jean-Philippe Lang

User-Impersonation lets you make a API request as if it was done by another user. You should be able to use it to set the issue author to a different
user. You just need to set the X-Redmine-Switch-User header of your API request to the login of the user that should be the author of the issue.
https://www.redmine.org/projects/redmine/wiki/Rest_api#User-Impersonation
https://www.redmine.org/projects/redmine/wiki/Rest_api
https://www.redmine.org/projects/redmine/wiki/Rest_Issues
https://www.redmine.org/projects/redmine/wiki/Rest_api#User-Impersonation
